unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    btnView: TButton;
    reResText: TRichEdit;
    edtResName: TEdit;
    Button1: TButton;
    procedure btnViewClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    DFS:TStringStream;
    procedure ExtractString(ResName: String; DFS: TStream);
    procedure ReadResString(ResName: String; DFS: TStream);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses ZLIB;
{$R *.DFM}


procedure TForm1.ExtractString(ResName: String; DFS: TStream);
var SFS:TStream;
    UZFS:TDecompressionStream;
    Res:Integer;
begin
  try
    SFS:=TResourceStream.Create(HInstance,ResName,RT_RCDATA);
    UZFS:=TDecompressionStream.Create(SFS);
    UZFS.ReadBuffer(Res,sizeOf(Res));
    DFS.CopyFrom(UZFS,Res);
    DFS.Seek(0,soFromBeginning);
  finally
    UZFS.Free;
    SFS.Free;
  end;
end;

procedure TForm1.ReadResString(ResName: String; DFS: TStream);
var SFS:TStream;
begin
  try
    SFS:=TResourceStream.Create(HInstance,ResName,RT_RCDATA);
    DFS.CopyFrom(SFS,SFS.Size);
    DFS.Seek(0,soFromBeginning);
  finally
    SFS.Free;
  end;
end;

procedure TForm1.btnViewClick(Sender: TObject);
begin
  ExtractString(edtResName.Text,DFS);
  reResText.Lines.Text:=DFS.DataString;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DFS:=TStringStream.Create('');
end;

procedure TForm1.Button1Click(Sender: TObject);
var FST:TStringStream;
begin
  ReadResString(ClassName,DFS);
  FST:=TStringStream.Create('');
  ObjectBinaryToText(DFS,FST);
  FST.Seek(0,soFromBeginning);
  reResText.Lines.Text:=FST.DataString;
end;

end.
